<template>
  <div v-if="pokemons" id="app">
      <div v-for="pokemon in pokemons.results" :key="pokemon.name" class="pokemon">
          <img :src="pokemon.image" :alt="pokemon.name">
          <h3>{{ pokemon.name }}</h3>
      </div>
      <div id="navigation">
          <button @click="decOffset" id="prevBtn" class="nes-btn is-primary nav-page-btn">&lt;</button>
          <h3>{{ currentPage }}</h3>
          <button @click="incOffset" id="nextBtn" class="nes-btn is-primary nav-page-btn">&gt;</button>
      </div>
  </div>
</template>

<script>
import gql from 'graphql-tag'

export default {
    name: 'App',
    data() {
        return {
            currentOffset: 0,
            currentPage: 1,
            pokemons: undefined
        }
    },
    mounted() {
        this.getPokemons()
    },
    methods: {
        async getPokemons() {
            const offset = this.currentOffset === undefined ? 0 : this.currentOffset
            const res = await this.$apollo.query({
                query: gql`query {
                pokemons(limit: 18, offset: ${offset}) {
                    count
                    results {
                        name
                        image
                    }
                }
                }`
            })
            this.pokemons = res.data.pokemons
        },
        decOffset() {
            if (this.currentOffset > 0) {
                this.currentPage--;
                this.currentOffset -= 18
                this.getPokemons()
            }
        },
        incOffset() {
            console.log("qs")
            if(this.pokemons.count > this.currentOffset) {
                this.currentPage++;
                this.currentOffset += 18
                this.getPokemons()
            }
        }
    }
}
</script>

<style>
@import url('https://fonts.googleapis.com/css2?family=Press+Start+2P&display=swap');

h3 {
    font-family: 'Press Start 2P', cursive;
}

#app {
    display: grid;
    grid-template-columns: repeat(3, 1fr);
}

#navigation {
    margin-top: 10%;
    display: flex;
    flex-direction: row;
    justify-content: space-between;
    align-items: center;
    grid-column: 2;
    grid-row: 7;
}

.pokemon {
    display: flex;
    flex-direction: column;
    justify-content: center;
    align-items: center;
}

.nav-page-btn {
    width: 3vw;
    text-align: center;
}

</style>
